<?php
require_once( TBLIGHT_PLUGIN_PATH . 'admin/models/paymentmethod.php' );
$paymentmethodModel = new PaymentmethodModel;
    
$redirectToListpage = false;

if(isset($_POST['action']) && $_POST['action'] == 'save') // FORM SUBMISSION
{
    $result = handle_form_submission();

    $postData = sanitize_post($_POST);
    $id = $postData['id'];

    if ( is_wp_error( $result ) ) {
        if ( is_wp_error( $result ) ) {
            echo '<div class="notice notice-error"><p>Ops, something went wrong. Please rectify this errors</p>';
            echo '<ul>';
                echo '<li>' . implode( '</li><li>', $result->get_error_messages() ) . '</li>';
            echo '</ul></div>';
        }
        
        if($id == 0) // new item
        {
            $item = $paymentmethodModel->getDefaultData();
            $heading = "Add a new Paymentmethod";
        }
        else
        {
            $item = $paymentmethodModel->getItemById($id);
            
            if(!empty($item)){
                $heading = "Edit Paymentmethod";
            }
        }
    
        require_once(TBLIGHT_PLUGIN_PATH . 'admin/views/paymentmethods/edit.php');
    }
    else {
        //echo "<pre>"; print_r($_POST); die();
        $newItemId = $paymentmethodModel->store($postData);
        
        if($newItemId > 0){
            wp_redirect( admin_url('admin.php?page=paymentmethods&success=1') );
            exit;
        }
    }
}

if(isset($_GET['action']))
{
    $action = $_GET['action'];
    $id = ( isset( $_GET['id'] ) ) ? absint($_GET['id']) : 0;
    
    if($action == "show")
    {
        $item = $paymentmethodModel->getItemById($id);
        $heading = "Paymentmethod Details";
        if(!empty($item)){
            require_once(TBLIGHT_PLUGIN_PATH . 'admin/views/paymentmethods/details.php');
        }
        else {
            $redirectToListpage = true;
        }
    }
    elseif ($action == "edit") {
        
        if($id == 0) // new item
        {
            $item = $paymentmethodModel->getDefaultData();
            $heading = "Add a new Paymentmethod";
            
            require_once(TBLIGHT_PLUGIN_PATH . 'admin/views/paymentmethods/edit.php');
        }
        else
        {
            $item = $paymentmethodModel->getItemById($id);
           
            if(!empty($item)){
                
                $data = json_decode($item->payment_params);

                $heading = "Edit Paymentmethod";
                require_once(TBLIGHT_PLUGIN_PATH . 'admin/views/paymentmethods/edit.php');
            }
            else {
                $redirectToListpage = true;
            }
        }
    }
    elseif ($action == "status") {
        
        // In our file that handles the request, verify the nonce.
        $nonce = esc_attr( $_REQUEST['_wpnonce'] );

        if ( ! wp_verify_nonce( $nonce, 'tblight_status_paymentmethod' ) ) {
            require_once(TBLIGHT_PLUGIN_PATH . 'admin/views/paymentmethods/list.php');
        }
        else {
            $paymentmethodModel->status($id);

            // esc_url_raw() is used to prevent converting ampersand in url to "#038;"
            // add_query_arg() return the current url
            wp_redirect( admin_url('admin.php?page=paymentmethods') );
            exit;
        }
        
    }    
    elseif ($action == "delete") {
        
        // In our file that handles the request, verify the nonce.
        $nonce = esc_attr( $_REQUEST['_wpnonce'] );

        if ( ! wp_verify_nonce( $nonce, 'tblight_delete_paymentmethod' ) ) {
            require_once(TBLIGHT_PLUGIN_PATH . 'admin/views/paymentmethods/list.php');
        }
        else {
            $paymentmethodModel->delete($id);

            // esc_url_raw() is used to prevent converting ampersand in url to "#038;"
            // add_query_arg() return the current url
            wp_redirect( admin_url('admin.php?page=paymentmethods') );
            exit;
        }
    }
}
else
{
    $redirectToListpage = true;
}

if($redirectToListpage){
    require_once(TBLIGHT_PLUGIN_PATH . 'admin/views/paymentmethods/list.php');
}

function handle_form_submission() {
    // do your validation, nonce and stuffs here

    // Instantiate the WP_Error object
    $error = new WP_Error();

    // Make sure user supplies the paymentmethod title
    if ( empty( $_POST['title'] ) ) {
        $error->add( 'empty', 'Title is required' );
    }
    
    // Send the result
    if ( !empty( $error->get_error_codes() ) ) {
        return $error;
    }
    
    // Everything is fine
    return true;
}