<?php

class ConfigModel
{
    public $dbtable;
    
    public function __construct()
    {
        global $wpdb;

        $this->dbtable = $wpdb->prefix.'tblight_configs';
    }
    
    public function getItems()
    {
        global $wpdb;
        
        $rows = $wpdb->get_results("SELECT * FROM ".$this->dbtable);
        
        return $rows;
    }
    
    public function getItemById($id = 0)
    {
        global $wpdb;
        
        $row = $wpdb->get_row("SELECT * FROM ".$this->dbtable." WHERE id='".$id."'");
        
        return $row;
    }
    
    public function getDefaultData()
    {
        $row = new stdClass;
        
        $row->id = 0;
        $row->title = '';

        return $row;
    }

    public function store($postData)
    {
        global $wpdb;
        
        $id = (int)$postData['id'];
        $title = $postData['title'];
        $alias = sanitize_title($postData['title']);
        
        if($id == 1) // general settings
        {
            $row = $wpdb->update($this->dbtable, 
                array(
                    "title" => $title,
                    "alias" => $alias,
                    "text" => json_encode($postData['configdata']),
                    "modified_by" => get_current_user_id(),
                    "modified" => current_time('Y-m-d H:i:s')
                ), 
                array(
                    "id" => $id
                )
            );
        }
        elseif($id == 2) // price settings
        {
            $row = $wpdb->update($this->dbtable, 
                array(
                    "title" => $title,
                    "alias" => $alias,
                    "text" => json_encode($postData['configdata']),
                    "modified_by" => get_current_user_id(),
                    "modified" => current_time('Y-m-d H:i:s')
                ), 
                array(
                    "id" => $id
                )
            );
        }
        elseif($id == 3) // map settings
        {
            $row = $wpdb->update($this->dbtable, 
                array(
                    "title" => $title,
                    "alias" => $alias,
                    "text" => json_encode($postData['configdata']),
                    "modified_by" => get_current_user_id(),
                    "modified" => current_time('Y-m-d H:i:s')
                ), 
                array(
                    "id" => $id
                )
            );
        }
        elseif($id == 4) // base settings
        {
            $row = $wpdb->update($this->dbtable, 
                array(
                    "title" => $title,
                    "alias" => $alias,
                    "text" => json_encode($postData['configdata']),
                    "modified_by" => get_current_user_id(),
                    "modified" => current_time('Y-m-d H:i:s')
                ), 
                array(
                    "id" => $id
                )
            );
        }
        elseif($id == 5) // orderemail settings
        {
            $postData['configdata']['header_info'] = $postData['header_info'];
            $postData['configdata']['contact_info'] = $postData['contact_info'];
            $row = $wpdb->update($this->dbtable, 
                array(
                    "title" => $title,
                    "alias" => $alias,
                    "text" => json_encode($postData['configdata']),
                    "modified_by" => get_current_user_id(),
                    "modified" => current_time('Y-m-d H:i:s')
                ), 
                array(
                    "id" => $id
                )
            );
        }
        elseif($id == 6) // terms settings
        {
            $postData['configdata']['terms_conditions'] = $postData['terms_conditions'];
            $row = $wpdb->update($this->dbtable, 
                array(
                    "title" => $title,
                    "alias" => $alias,
                    "text" => json_encode($postData['configdata']),
                    "modified_by" => get_current_user_id(),
                    "modified" => current_time('Y-m-d H:i:s')
                ), 
                array(
                    "id" => $id
                )
            );
        }
        elseif($id == 7) // design settings
        {
            
            if ($postData['configdata']['show_map_in_popup_only'] == 1) {
            $postData['configdata']['show_map_on_desktop'] = $postData['configdata']['show_map_on_mobile'] = 0;
            }
            
            $row = $wpdb->update($this->dbtable, 
                array(
                    "title" => $title,
                    "alias" => $alias,
                    "text" => json_encode($postData['configdata']),
                    "modified_by" => get_current_user_id(),
                    "modified" => current_time('Y-m-d H:i:s')
                ), 
                array(
                    "id" => $id
                )
            );
        }
        
        return $id;
    }
    
    public function delete($id = 0)
    {
        global $wpdb;
        
        $wpdb->query("DELETE FROM ".$this->dbtable." WHERE id = '".esc_sql($id)."'");
        
        return true;
    }
}