<?php

class PaymentmethodModel
{
    public $dbtable;
    
    public function __construct()
    {
        global $wpdb;

        $this->dbtable = $wpdb->prefix.'tblight_paymentmethods';
    }
    
    public function getItems()
    {
        global $wpdb;
        
        $rows = $wpdb->get_results("SELECT * FROM ".$this->dbtable);
        
        return $rows;
    }
    
    public function getItemById($id = 0)
    {
        global $wpdb;
        
        $row = $wpdb->get_row("SELECT * FROM ".$this->dbtable." WHERE id='".$id."'");
        
        return $row;
    }
    
    public function getDefaultData()
    {
        $row = new stdClass;
        
        $row->id = 0;
        $row->title = '';
        $row->state = 1;
        $row->payment_element = '';
        $row->payment_params = array();
        $row->language = '';
        $row->text = '';

        return $row;
    }

    public function store($postData)
    {
        global $wpdb;
        
        $id = (int)$postData['id'];
        $title = $postData['title'];
        $alias = sanitize_title($postData['title']);
        $state = $postData['state'];
        $payment_element = $postData['payment_element'];
        $text = $postData['text'];
        if ($postData['payment_element']=='paypal') {
            $state = 0;
        }        
        
        if ($id == 0) // New Item
        {
            $payment_params = $this->getPaymentParams($payment_element);
            
            $row = $wpdb->insert($this->dbtable, 
                array(
                    "title" => $title,
                    "alias" => $alias,
                    "state" => $state,
                    "payment_element" => $payment_element,
                    "payment_params" => json_encode($payment_params),
                    "text" => $text,
                    "created_by" => get_current_user_id(),
                    "created" => current_time('Y-m-d H:i:s')
                ),
                array(
                    '%s', //title
                    '%s', //alias
                    '%d', //state
                    '%s', //payment_element
                    '%s', //payment_params
                    '%s', //text
                    '%d', //created_by
                    '%s'  //created
                )
            );
            
            $id = (int)$wpdb->insert_id;
        }
        elseif ($id > 0)
        {
            $row = $wpdb->update($this->dbtable, 
                array(
                    "title" => $title,
                    "alias" => $alias,
                    "state" => $state,
                    "payment_element" => $payment_element,
                    "payment_params" => json_encode($postData['params']),
                    "text" => $text,
                    "modified_by" => get_current_user_id(),
                    "modified" => current_time('Y-m-d H:i:s')
                ), 
                array(
                    "id" => $id
                )
            );
        }
        
        return $id;
    }
    
    public function delete($id = 0)
    {
        global $wpdb;
        
        $wpdb->query("DELETE FROM ".$this->dbtable." WHERE id = '".esc_sql($id)."'");
        
        return true;
    }

    public function status($id = 0)
    {
        global $wpdb;

        $row = $wpdb->get_row("SELECT state FROM ".$this->dbtable." WHERE id='".$id."'");
        
        if ($row->state == 0) {
            $wpdb->update( $this->dbtable, array( 'state' => 1),array('id'=>esc_sql($id)));
        } else {
            $wpdb->update( $this->dbtable, array( 'state' => 0),array('id'=>esc_sql($id)));
        }
        
        return true;
    }

    private function getPaymentParams($payment_element = 'cash')
    {
        if($payment_element == 'cash')
        {
            $params = array('min_amount' => '',
                            'max_amount' => '',
                            'cost_per_transaction' => '',
                            'cost_percent_total' => '',
                            'default_status' => -2,
                        );
        }
        elseif($payment_element == 'paypal')
        {
            $params = array('sandbox' => 1,
                            'paypal_merchant_email' => '',
                            'sandbox_merchant_email' => '',
                            'min_amount' => '',
                            'max_amount' => '',
                            'cost_per_transaction' => '',
                            'cost_percent_total' => '',
                            'prepayment_percent' => '100',
                            'status_pending' => -2,
                            'status_success' => 1,
                            'status_canceled' => 0,
                            'send_email_pending_status' => 1,
                            'send_email_approved_status' => 1,
                            'debug' => 0,
                        );

        }

        return $params;
    }
}