<?php require_once(TBLIGHT_PLUGIN_PATH . 'fields/select.list.php'); ?>
<style type="text/css">
.map-canvas-wrapper {
    margin: 20px 10px 10px 0px;
    padding: 10px 10px 10px 0px;
    min-height: 350px; 
    height: 350px; 
    width: 100%;	
}
#map-canvas {
    width: 100%;
    height: 100%;
}
.map-canvas-wrapper img {
    max-width: inherit !important;
}
#panel {
    position: absolute;
    top: 50px;
    left: 50%;
    margin-left: -50px;
    z-index: 5;
    background-color: #fff;
    padding: 5px;
    border: 1px solid #999;
}
.base-coords-wrap {

}
.base-coords-wrap .control-group {
	display: inline-block;
}
.base-coords-wrap .get_base_coords {
	display: inline-block;	
}
</style>

<?php 
require_once(TBLIGHT_PLUGIN_PATH . 'classes/booking.helper.php');
$elsettings = BookingHelper::config();
$gmap_api_key = $elsettings->api_key;

$default_operation_area_vertices = '[[51.629949539313905,-0.5104715976563057],[51.36834810929568,-0.3786356601563057],[51.447157400846535,0.2695576992186943],[51.83916879427223,0.3189961757811943]]';

if($gmap_api_key!=""){?>
<script type="text/javascript" src="https://maps.googleapis.com/maps/api/js?v=3&key=<?php echo $gmap_api_key;?>"></script>
<?php } else { ?>
<script type="text/javascript" src="https://maps.googleapis.com/maps/api/js?v=3"></script>
<?php } ?>

<script src="<?php echo TBLIGHT_PLUGIN_DIR_URL ;?>assets/js/google.maps.Polygon.getBounds.js"></script>
<script src="<?php echo TBLIGHT_PLUGIN_DIR_URL ;?>assets/js/google.maps.Polygon.moveTo.js"></script>    

<script type="text/javascript">
var map,areaOfOperation,geocoder;
var selectedAreaVerticesStr = '<?php echo $data->operation_area_vertices; ?>';
var triangleCoords = new Array();
var selectedAreaVerticesArr = JSON.parse(selectedAreaVerticesStr);

var defaultAreaVerticesStr = '<?php echo $default_operation_area_vertices; ?>';
var defaultAreaVerticesArr = JSON.parse(defaultAreaVerticesStr);

var base_lat = '<?php echo $data->base_lat;?>';
var base_lng = '<?php echo $data->base_long;?>';

function initialize() {
    
    geocoder = new google.maps.Geocoder();
    
    var mapOptions = {
	zoom: 7,
	center: new google.maps.LatLng(0, 0),
	mapTypeId: google.maps.MapTypeId.ROADMAP
    };
    
    map = new google.maps.Map(document.getElementById('map-canvas'), mapOptions);
    
    var bounds = new google.maps.LatLngBounds();
    for (var i =0; i < selectedAreaVerticesArr.length; i++) {
	    var myLatLng = new google.maps.LatLng(selectedAreaVerticesArr[i][0],selectedAreaVerticesArr[i][1]);
	    triangleCoords.push(myLatLng);
	    bounds.extend(myLatLng);
    }
    map.fitBounds(bounds);

    // Construct the polygon.
    areaOfOperation = new google.maps.Polygon({
	paths: triangleCoords,
	strokeColor: '#FF0000',
	strokeOpacity: 0.8,
	strokeWeight: 2,
	fillColor: '#FF0000',
	fillOpacity: 0.35,
	draggable: true,
	editable: true
    });
  
    areaOfOperation.setMap(map);
    
     // Add a listener for the click event.
    google.maps.event.addListener(areaOfOperation, 'click', showArrays);
    google.maps.event.addListener(areaOfOperation, 'dragend', showArrays);
    google.maps.event.addListener(areaOfOperation, 'mouseup', showArrays);
    google.maps.event.addListener(areaOfOperation, 'mouseout', showArrays);
}

function showArrays(event) {

    // Since this polygon has only one path, we can call getPath()
    // to return the MVCArray of LatLngs.
    var vertices = this.getPath();
    //var contentString = '<b>Bermuda Triangle polygon</b><br>Clicked location: <br>' + event.latLng.lat() + ',' + event.latLng.lng() +'<br>';
  
    // Iterate over the vertices.
    var newAreaVertices = new Array();
    for (var i =0; i < vertices.getLength(); i++) {
	var xy = vertices.getAt(i);
	newAreaVertices.push(new Array(xy.lat(),xy.lng()));
	//contentString += '<br>' + 'Coordinate ' + i + ':<br>' + xy.lat() + ',' + xy.lng();
    }
    
    window.parent.document.getElementById('operation_area_vertices').value = JSON.stringify(newAreaVertices);
}

function resetArea() {
    var triangleCoords = new Array();
    
    var mapOptions = {
	zoom: 7,
	center: new google.maps.LatLng(0, 0),
	mapTypeId: google.maps.MapTypeId.ROADMAP
    };
    
    map = new google.maps.Map(document.getElementById('map-canvas'), mapOptions);
    
    var bounds = new google.maps.LatLngBounds();
    for (var i =0; i < defaultAreaVerticesArr.length; i++) {
	    var myLatLng = new google.maps.LatLng(defaultAreaVerticesArr[i][0],defaultAreaVerticesArr[i][1]);
	    triangleCoords.push(myLatLng);
	    bounds.extend(myLatLng);
    }
    map.fitBounds(bounds);
  
    // Construct the polygon.
    areaOfOperation = new google.maps.Polygon({
	paths: triangleCoords,
	strokeColor: '#FF0000',
	strokeOpacity: 0.8,
	strokeWeight: 2,
	fillColor: '#FF0000',
	fillOpacity: 0.35,
	draggable: true,
	editable: true
    });
  
    areaOfOperation.setMap(map);
    window.parent.document.getElementById('operation_area_vertices').value = JSON.stringify(defaultAreaVerticesArr);
}

google.maps.event.addDomListener(window, 'load', initialize);

jQuery(document).ready(function(){
	jQuery('.btn-group-yesno label.btn').click(function () {
		if (jQuery(this).prop("checked")) {
			// checked
			return;
		}
		jQuery(this).siblings('.btn').removeClass('active');
		jQuery(this).addClass('active');
		jQuery(this).parent('.btn-group-yesno').children('input').attr('checked', false);
		jQuery(this).prev('input').attr('checked', true);
	});
	jQuery('.drop_off_base_calculation_key label.btn').click(function(){
		if (jQuery(this).text()=='No') {
			jQuery(this).closest('.drop_off_base_calculation_key').siblings('.drop_off_base_calculation_option').hide('slow');
		} else {
			jQuery(this).closest('.drop_off_base_calculation_key').siblings('.drop_off_base_calculation_option').show('slow');
		}
	});
	jQuery('.pick_up_base_calculation_key label.btn').click(function(){
		if (jQuery(this).text()=='No') {
			jQuery(this).closest('.pick_up_base_calculation_key').siblings('.pick_up_base_calculation_option').hide('slow');
		} else {
			jQuery(this).closest('.pick_up_base_calculation_key').siblings('.pick_up_base_calculation_option').show('slow');
		}
	});		
	
    jQuery('#default_country,#default_city').change(function(){
	    
	    // if country is changed, clear out city
	    if(jQuery(this).attr('id')=='default_country'){
		jQuery('#default_city').val("");
	    }
	    var address = jQuery('#default_country :selected').text();
	    
	    if(jQuery('#default_city').val()!=""){
		    address += ' '+jQuery('#default_city').val();
	    }
	    geocoder.geocode( { 'address': address}, function(results, status) {
		if (status == google.maps.GeocoderStatus.OK) {
		    
		    jQuery('#company_location_lat').val(results[0].geometry.location.lat());
		    jQuery('#company_location_lng').val(results[0].geometry.location.lng());
		    
		    map.setCenter(results[0].geometry.location);
		    // Move the 2nd polygon to a new location
		    // @note: when geodesic is set to false it's recommened to use setTimeout() in order to have the getProjection() function available on the map
		    areaOfOperation.moveTo(results[0].geometry.location);
		    
		    var newAreaVertices = new Array();
		    areaOfOperation.getPath().forEach(function(elem, index){
			    newAreaVertices.push(new Array(elem.lat(),elem.lng()));
		    });
		    document.getElementById('operation_area_vertices').value = JSON.stringify(newAreaVertices);
		} else {
		      //alert("Geocode was not successful for the following reason: " + status);
		}
	    });
    });

    jQuery('a.get_base_coords').click(function(){
	jQuery('html, body').animate({ scrollTop: jQuery('#map-canvas').offset().top }, 'fast');
	if(base_lat!="" && base_lng!=""){
	    var base_marker = new google.maps.Marker({
		position: new google.maps.LatLng(base_lat,base_lng),
		map: map,
		draggable:true,
		animation: google.maps.Animation.DROP,
		title: 'Base'
	    });
	}
	else {
	    var base_marker = new google.maps.Marker({
		position: new google.maps.LatLng(selectedAreaVerticesArr[0][0],selectedAreaVerticesArr[0][1]),
		map: map,
		draggable:true,
		animation: google.maps.Animation.DROP,
		title: 'Base'
	    });
	}
	google.maps.event.addListener(base_marker, 'dragend', function (event) {
	    document.getElementById("base_lat").value = this.getPosition().lat();
	    document.getElementById("base_long").value = this.getPosition().lng();
	});
    })
});
</script>

<legend class="block-heading"><?php echo $heading;?></legend>
<div class="tblight-wrap">
	
	<form method="post" name="admin-form" id="admin-form" class="admin-form validate">
	
		<?php wp_nonce_field( 'create-base-config', 'tblight_create_base_config' ); ?>
		<input type="hidden" name="action" value="save" />
		<?php // echo "<pre>"; print_r($item); echo "</pre>"; ?>
		<input type="hidden" name="title" id="title" value="Base Settings" />
		
		<div class="form-group clearfix defaultcountry_form_field">
			<label class="label">Default Country</label>
			<div>
				<?php echo SelectList::getCountryOptions('configdata[default_country]', 'default_country', $data->default_country) ?>
			</div>			
		</div>
		<div class="form-group clearfix defaultcity_form_field">
			<label class="label">Default City</label>
			<input type="text" name="configdata[default_city]" id="default_city" class="form-control mid-text" value="<?php echo $data->default_city; ?>" />
		</div>
		<input type="hidden" name="configdata[company_location_lat]" id="company_location_lat" value="<?php echo $data->company_location_lat; ?>" />
		<input type="hidden" name="configdata[company_location_lng]" id="company_location_lng" value="<?php echo $data->company_location_lng; ?>" />
		<div class="form-group clearfix notificationemail_form_field">
			<label class="label">Booking notification email</label>
			<input type="text" name="configdata[booking_notification_email]" id="booking_notification_email" class="form-control mid-text" value="<?php echo $data->booking_notification_email; ?>" />
		</div>
	    <div class="inputwrap clearfix" style="position:relative;">
			<label>Area of Operation</label>
			<input type="hidden" name="configdata[operation_area_vertices]" id="operation_area_vertices" value="<?php echo $data->operation_area_vertices; ?>" />
			<div id="panel">
			    <input onclick="resetArea();" type=button value="Reset Area" />
			</div>
			
			<div class="map-canvas-wrapper">
				<div id="map-canvas"></div>
			</div>
	    </div>

		<div class="form-group clearfix pickarea_form_field">
			<label class="label">Pickup in Area</label>
			<fieldset id="pickup_in_area" class="btn-group btn-group-yesno radio">
				<input type="radio" id="pickup_in_area1" name="configdata[pickup_in_area]" value="1" <?php echo ($data->pickup_in_area)?'checked="checked"':''; ?> />
				<label for="pickup_in_area1" class="btn <?php echo ($data->pickup_in_area)?'active':''; ?>">Yes</label>
				<input type="radio" id="pickup_in_area0" name="configdata[pickup_in_area]" value="0" <?php echo ($data->pickup_in_area)?'':'checked="checked"'; ?> />
				<label for="pickup_in_area0" class="btn <?php echo ($data->pickup_in_area)?'':'active'; ?>">No</label>
			</fieldset>
		</div>	
		<div class="form-group clearfix dropoff_form_field">
			<label class="label">Drop off in Area</label>
			<fieldset id="dropoff_in_area" class="btn-group btn-group-yesno radio">
				<input type="radio" id="dropoff_in_area1" name="configdata[dropoff_in_area]" value="1" <?php echo ($data->dropoff_in_area)?'checked="checked"':''; ?> />
				<label for="dropoff_in_area1" class="btn <?php echo ($data->dropoff_in_area)?'active':''; ?>">Yes</label>
				<input type="radio" id="dropoff_in_area0" name="configdata[dropoff_in_area]" value="0" <?php echo ($data->dropoff_in_area)?'':'checked="checked"'; ?> />
				<label for="dropoff_in_area0" class="btn <?php echo ($data->dropoff_in_area)?'':'active'; ?>">No</label>
			</fieldset>
		</div>
		<div class="form-group clearfix bothpickanddropoff_form_field">
			<label class="label">Both pick up and drop off in Area</label>
			<fieldset id="pickup_dropoff_in_area" class="btn-group btn-group-yesno radio">
				<input type="radio" id="pickup_dropoff_in_area1" name="configdata[pickup_dropoff_in_area]" value="1" <?php echo ($data->pickup_dropoff_in_area)?'checked="checked"':''; ?> />
				<label for="pickup_dropoff_in_area1" class="btn <?php echo ($data->pickup_dropoff_in_area)?'active':''; ?>">Yes</label>
				<input type="radio" id="pickup_dropoff_in_area0" name="configdata[pickup_dropoff_in_area]" value="0" <?php echo ($data->pickup_dropoff_in_area)?'':'checked="checked"'; ?> />
				<label for="pickup_dropoff_in_area0" class="btn <?php echo ($data->pickup_dropoff_in_area)?'':'active'; ?>">No</label>
			</fieldset>
		</div> 
	    <div class="base-coords-wrap latitide_form_field">
		<div class="form-group clearfix">
			<label class="label">Base Latitude</label>
			<input type="text" name="configdata[base_lat]" id="base_lat" class="form-control mid-text" value="<?php echo $data->base_lat; ?>" />
		</div>
	    <a href="javascript:void(0);" class="get_base_coords">Get Coords</a>
		</div>
		<div class="form-group clearfix longitude_form_field">
			<label class="label">Base Longitude</label>
			<input type="text" name="configdata[base_long]" id="base_long" class="form-control mid-text" value="<?php echo $data->base_long; ?>" />
		</div>

		<div class="form-group clearfix pick_up_base_calculation_key">
			<label class="label">Base to Pick up calculation?</label>
			<fieldset id="calculate_base_pickup" class="btn-group btn-group-yesno radio">
				<input type="radio" id="calculate_base_pickup1" name="configdata[calculate_base_pickup]" value="1" <?php echo ($data->calculate_base_pickup)?'checked="checked"':''; ?> />
				<label for="calculate_base_pickup1" class="btn <?php echo ($data->calculate_base_pickup)?'active':''; ?>">Yes</label>
				<input type="radio" id="calculate_base_pickup0" name="configdata[calculate_base_pickup]" value="0" <?php echo ($data->calculate_base_pickup)?'':'checked="checked"'; ?> />
				<label for="calculate_base_pickup0" class="btn <?php echo ($data->calculate_base_pickup)?'':'active'; ?>">No</label>
			</fieldset>
		</div>
		<div class="form-group clearfix pick_up_base_calculation_option" style="<?php echo ($data->calculate_base_pickup)?'display:block;':'display:none;'; ?>">
			<label class="label">Base to Pick up charge</label>
			<fieldset id="base_pickup_price_type" class="btn-group btn-group-yesno radio">
				<input type="radio" id="base_pickup_price_type1" name="configdata[base_pickup_price_type]" value="flat" <?php echo ($data->base_pickup_price_type=='flat')?'checked="checked"':''; ?> />
				<label for="base_pickup_price_type1" class="btn <?php echo ($data->base_pickup_price_type=='flat')?'active':''; ?>">Flat rate</label>
				<input type="radio" id="base_pickup_price_type0" name="configdata[base_pickup_price_type]" value="distance" <?php echo ($data->base_pickup_price_type=='distance')?'':'checked="checked"'; ?> />
				<label for="base_pickup_price_type0" class="btn <?php echo ($data->base_pickup_price_type=='distance')?'active':''; ?>">Per unit distance</label>
			</fieldset>
		</div>
		<div class="form-group clearfix pick_up_base_calculation_option" style="<?php echo ($data->calculate_base_pickup)?'display:block;':'display:none;'; ?>">
			<label class="label">Value</label>
			<input type="text" name="configdata[base_pickup_price]" id="base_pickup_price" class="form-control mid-text" value="<?php echo $data->base_pickup_price; ?>" />
		</div>
		<div class="form-group clearfix pick_up_base_calculation_option" style="<?php echo ($data->calculate_base_pickup)?'display:block;':'display:none;'; ?>">
			<label class="label">Charge if Base to Pick up over miles/kilomerters</label>
			<input type="text" name="configdata[milage_charging_base_pickup]" id="milage_charging_base_pickup" class="form-control mid-text" value="<?php echo $data->milage_charging_base_pickup; ?>" />
		</div>

		<div class="form-group clearfix drop_off_base_calculation_key">
			<label class="label">Drop off to Base calculation?</label>
			<fieldset id="calculate_dropoff_base" class="btn-group btn-group-yesno radio">
				<input type="radio" id="calculate_dropoff_base1" name="configdata[calculate_dropoff_base]" value="1" <?php echo ($data->calculate_dropoff_base)?'checked="checked"':''; ?> />
				<label for="calculate_dropoff_base1" class="btn <?php echo ($data->calculate_dropoff_base)?'active':''; ?>">Yes</label>
				<input type="radio" id="calculate_dropoff_base0" name="configdata[calculate_dropoff_base]" value="0" <?php echo ($data->calculate_dropoff_base)?'':'checked="checked"'; ?> />
				<label for="calculate_dropoff_base0" class="btn <?php echo ($data->calculate_dropoff_base)?'':'active'; ?>">No</label>
			</fieldset>
		</div>
		<div class="form-group clearfix drop_off_base_calculation_option" style="<?php echo ($data->calculate_dropoff_base)?'display:block;':'display:none;'; ?>">
			<label class="label">Drop off to Base charge</label>
			<fieldset id="dropoff_base_price_type" class="btn-group btn-group-yesno radio">
				<input type="radio" id="dropoff_base_price_type1" name="configdata[dropoff_base_price_type]" value="flat" <?php echo ($data->dropoff_base_price_type=='flat')?'checked="checked"':''; ?> />
				<label for="dropoff_base_price_type1" class="btn <?php echo ($data->dropoff_base_price_type=='flat')?'active':''; ?>">Flat rate</label>
				<input type="radio" id="dropoff_base_price_type0" name="configdata[dropoff_base_price_type]" value="distance" <?php echo ($data->dropoff_base_price_type=='distance')?'':'checked="checked"'; ?> />
				<label for="dropoff_base_price_type0" class="btn <?php echo ($data->dropoff_base_price_type=='distance')?'active':''; ?>">Per unit distance</label>
			</fieldset>
		</div>
		<div class="form-group clearfix drop_off_base_calculation_option" style="<?php echo ($data->calculate_dropoff_base)?'display:block;':'display:none;'; ?>">
			<label class="label">Value</label>
			<input type="text" name="configdata[dropoff_base_price]" id="dropoff_base_price" class="form-control mid-text" value="<?php echo $data->dropoff_base_price; ?>" />
		</div>
		<div class="form-group clearfix drop_off_base_calculation_option" style="<?php echo ($data->calculate_dropoff_base)?'display:block;':'display:none;'; ?>">
			<label class="label">Charge if Drop off to Base over miles/kilomerters</label>
			<input type="text" name="configdata[milage_charging_dropoff_base]" id="milage_charging_dropoff_base" class="form-control mid-text" value="<?php echo $data->milage_charging_dropoff_base; ?>" />
		</div>
		<div class="form-group clearfix timeaftereachbooking_form_field">
			<label class="label">Add time after each booking (minutes)</label>
			<input type="text" name="configdata[time_after_each_booking]" id="time_after_each_booking" class="form-control mid-text" value="<?php echo $data->time_after_each_booking; ?>" />
		</div>
		
		<input type="hidden" name="id" value="<?php echo $id; ?>" />
		<input type="submit" name="submit" id="submit" class="button button-primary submit-base-config" value="Save" ?>
		<a href="<?php echo admin_url('admin.php?page=configs'); ?>" class="button" data-action="back">Cancel</a>
	</form>
	
</div>