<?php
require_once(TBLIGHT_PLUGIN_PATH . 'classes/booking.helper.php');
require_once(TBLIGHT_PLUGIN_PATH . 'fields/select.list.php');
$elsettings = BookingHelper::config();
if(isset($_GET['success']) && $_GET['success'] == 1){
?>
<div class="notice notice-success is-dismissible">
    <p><?php _e( 'Successfully saved!', 'sample-text-domain' ); ?></p>
</div>
<?php 
}
?>
<script type="text/javascript">
var filePath = "<?php echo TBLIGHT_PLUGIN_DIR_URL;?>";
var itemID = "<?php echo $item->id; ?>";
</script>
<?php wp_enqueue_script( 'orders-custom-details', TBLIGHT_PLUGIN_DIR_URL . 'admin/js/orders_details.js' ); ?>
<legend class="block-heading"><?php echo $heading;?></legend>

<div class="action-btn-wrapper">	
<a href="<?php echo admin_url('admin.php?page=orders'); ?>" class="button" data-action="back">Back</a> 
<a href="<?php echo admin_url('admin.php?page=orders&action=edit&id='.$id); ?>" class="button" data-action="edit">Edit</a>
</div>
<?php //echo "<pre>"; print_r($item); echo "</pre>"; ?>
<div class="tblight-wrap">    
	<div class="inputWrap clearfix">
		<label>Order Number</label>
		<div class="field-value"><?php echo $item->order_number; ?></div>
	</div>
	<div class="inputWrap clearfix">
		<label>State</label>
		<div class="field-value">
			<?php echo BookingHelper::get_order_status_text($item); ?>
			<a href="javascript:void(0)" class="change_property_trigger">Change</a>
			<div class="change_property_wrap" style="display: none;">
				<?php echo SelectList::getDefaultOrderStatusOptions("state", "styler_list", $item->state); ?>
				<a href="javascript:void(0);" class="cancel_trigger">Cancel</a>
			</div>
		</div>
	</div>		
	<div class="inputWrap clearfix">
		<label>Name</label>
		<div class="field-value"><?php echo $item->names; ?></div>
	</div>
	<div class="inputWrap clearfix">
		<label>Email</label>
		<div class="field-value"><?php echo $item->email; ?></div>
	</div>
	<div class="inputWrap clearfix">
		<label>Phone</label>
		<div class="field-value"><?php echo '+'. $item->country_calling_code . ' ' . $item->phone; ?></div>
	</div>
	<div class="inputWrap clearfix">
		<label>Passengers</label>
		<div class="field-value"><?php echo $item->selpassengers; ?></div>
	</div>
	<div class="inputWrap clearfix">
		<label>Check in luggage</label>
		<div class="field-value"><?php echo $item->selluggage; ?></div>
	</div>
	<div class="inputWrap clearfix">
		<label>Child Seats</label>
		<div class="field-value"><?php echo $item->selchildseats; ?></div>
	</div>
	<div class="inputWrap clearfix">
		<label>Vehicle Type</label>
		<div class="field-value"><?php echo BookingHelper::get_order_car($item); ?></div>
	</div>
	<div class="inputWrap clearfix">
		<label>Pick Up Date</label>
		<div class="field-value">
			<?php echo BookingHelper::date_format($item->datetime1, 'Y-m-d H:i:s', $elsettings); ?>
		</div>
	</div>
	<div class="inputWrap clearfix">
		<label>Drop Off Date</label>
		<div class="field-value">
			<?php 
			$item->datetime2 = $item->datetime1 + $item->duration;
			echo BookingHelper::date_format($item->datetime2, 'Y-m-d H:i:s', $elsettings); ?>
		</div>
	</div>
	<div class="inputWrap clearfix">
		<label>From</label>
		<div class="field-value"><?php echo $item->begin; ?></div>
	</div>
	<div class="inputWrap clearfix">
		<label>To</label>
		<div class="field-value"><?php echo $item->end; ?></div>
	</div>
	<div class="inputWrap clearfix">
		<label>Distance</label>
		<div class="field-value">
		    <?php
			    $distance_text = number_format($item->distance,2).' '.$elsettings->distance_unit.'s';
			    echo $distance_text;
		    ?>		
		</div>
	</div>
	<div class="inputWrap clearfix">
		<label>Trip Duration</label>
		<div class="field-value"><?php echo $item->duration_text; ?></div>
	</div>
	<?php if($item->sub_total != 0){ ?>
	<div class="inputWrap clearfix">
		<label>Sub Total</label>
		<div class="field-value"><?php echo $item->sub_total; ?></div>
	</div>
	<?php } ?>

	<?php if($item->flat_cost != 0){ ?>
	<div class="inputWrap clearfix">
		<label>Flat cost</label>
		<div class="field-value"><?php echo $item->flat_cost; ?></div>
	</div>
	<?php } ?>

	<?php if($item->percentage_cost != 0){ ?>
	<div class="inputWrap clearfix">
		<label>Percentage cost</label>
		<div class="field-value"><?php echo $item->percentage_cost; ?></div>
	</div>
	<?php } ?>

	<div class="inputWrap clearfix">
		<label>Grand Total</label>
		<div class="field-value"><?php echo $item->cprice; ?></div>
	</div>
	

	<?php if($item->custom_payment!=''){ ?>
	<div class="inputWrap clearfix">
		<label>Payment</label>
		<div class="field-value"><?php echo BookingHelper::get_order_payment($item);?></div>
	</div>
	<?php } ?>
	
	<?php if($item->payment_notes != ''){ ?>
	<div class="inputWrap clearfix">
		<label>Payment notes</label>
		<div class="field-value"><?php echo $item->payment_notes; ?></div>
	</div>
	<?php } ?>

	<?php 
	$payment_data = '';
	$paymentObj = BookingHelper::get_payment_details($item->payment);
	if(!empty($paymentObj))
	{
		if(!empty($paymentObj->payment_element) && file_exists(TBLIGHT_PLUGIN_PATH . 'classes/payment_plugins/'.$paymentObj->payment_element.'.php'))
		{
			require_once(TBLIGHT_PLUGIN_PATH . 'classes/tbpayment.helper.php');
			require_once(TBLIGHT_PLUGIN_PATH . 'classes/payment_plugins/'.$paymentObj->payment_element.'.php');
			
			$pluginTitle = 'plgTblightPayment'.ucfirst($paymentObj->payment_element);
			$tbPaymentPlugin = new $pluginTitle();
			$payment_data = $tbPaymentPlugin->plgTbOnShowOrderBEPayment($item->id, $item->payment);
		}
	}
	echo $payment_data;
	?>
</div>